<id>
HotLinks for SP 1.3.1
</id>

<version>
1.2
</version>

<mod info>

This mod lets admin create a list of words that will appear as links in posts, IM's and signatures.

Apply this mod.

Upload (in ASCII mode):
english.lng
Sources/Admin.pl
Sources/Display.pl
Sources/InstantMessage.pl
Sources/Load.pl
Sources/Post.pl
Sources/SubList.pl

Variables/hotlink.txt  (chmod 666)

Upload to your YaBBImages folder (in binary mode):
hotlink.gif

Go to Admin Center - Forum Configuration and click on the new "Set Hotlink Words" link
to add/change your Hotlink Words.

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>


<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>

%htltxt = (
'01' => "Set Hotlink Words",
'02' => "One word per line in the form\: hotword,n=www.url_to_hotword.com",
'03' => "n: 0 = same window, 1 = new window",
'04' => "Hotlink color",
'05' => "Default",
'06' => "Hotlink font",
'07' => "Arial",
'08' => "Verdana",
'09' => "Courier",
'10' => "White",
'11' => "Gray",
'12' => "Enable Hotlinks in",
'13' => "Posts",
'14' => "Instant Messages",
'15' => "Signatures",
'16' => "Ctrl + left-click to<br>add/remove"
);

</add before>


<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=setcensor">$txt{'135'}</a>
</search for>

<add after>
        <br>- <a href="$cgi;action=sethotlink">$htltxt{'01'}</a>
</add after>


<search for>
sub AdminMembershipRecount {
</search for>

<add before>

sub SetHotlink {
	&is_admin;
	my(@hotlinks, @hotcolor, @hotenable, $i, $encheck1, $encheck2, $encheck3, $check0, $check1, $check2, $check3, $check4, $check5, $check6, $check7, $check8, $check9, $check10, $check11, $check12, $check13, $check14, $check15, $check16 ,$fcheck0, $fcheck1, $fcheck2, $fcheck3);

	fopen(FILE, "$vardir/hotlink.txt");
	@hotlinks = <FILE>;
	fclose(FILE);
	foreach $i (@hotlinks) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	fopen(FILE, "$vardir/hotlink.col");
	@hotcolor = <FILE>;
	fclose(FILE);
	chomp(@hotcolor);
	if($hotcolor[0] eq "Black") { $check1 = "selected" }
	elsif($hotcolor[0] eq "White") { $check2 = "selected" }
	elsif($hotcolor[0] eq "Gray") { $check3 = "selected" }
	elsif($hotcolor[0] eq "Red") { $check4 = "selected" }
	elsif($hotcolor[0] eq "Yellow") { $check5 = "selected" }
	elsif($hotcolor[0] eq "Pink") { $check6 = "selected" }
	elsif($hotcolor[0] eq "Green") { $check7 = "selected" }
	elsif($hotcolor[0] eq "Orange") { $check8 = "selected" }
	elsif($hotcolor[0] eq "Purple") { $check9 = "selected" }
	elsif($hotcolor[0] eq "Blue") { $check10 = "selected" }
	elsif($hotcolor[0] eq "Beige") { $check11 = "selected" }
	elsif($hotcolor[0] eq "Brown") { $check12 = "selected" }
	elsif($hotcolor[0] eq "Teal") { $check13 = "selected" }
	elsif($hotcolor[0] eq "Navy") { $check14 = "selected" }
	elsif($hotcolor[0] eq "Maroon") { $check15 = "selected" }
	elsif($hotcolor[0] eq "LimeGreen") { $check16 = "selected" }
	else { $check0 = "selected" }
	if($hotcolor[1] eq "Arial") { $fcheck1 = "selected" }
	elsif($hotcolor[1] eq "Verdana") { $fcheck2 = "selected" }
	elsif($hotcolor[1] eq "Courier") { $fcheck3 = "selected" }
	else { $fcheck0 = "selected" }
	(@hotenable) = split(/\,/,$hotcolor[2],3);
	$hot_post = 0; $hot_im = 0; $hot_sign = 0; 
	if($hotenable[0]) { $hot_post = 1; $encheck1 = "selected" }
	if($hotenable[1]) { $hot_im = 1; $encheck2 = "selected" }
	if($hotenable[2]) { $hot_sign = 1; $encheck3 = "selected" }
	$yymain .= qq~
<table border="0" width="300" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <form action="$cgi;action=sethotlink2" method="POST">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
      <img src="$imagesdir/hotlink.gif" alt="" border="0" align="absmiddle">
      <font size="2" class="text1" color="$color{'titletext'}"><b>$htltxt{'01'}</b></font>
    </td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center">
      <font size="2">$htltxt{'02'}<br>$htltxt{'03'}</font>
    <textarea style="font-size: 10px; width: 620px" cols=90 rows=10 name="hotlink">
~;
	foreach $i (@hotlinks) {
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		$yymain .= "$i\n";
	}
	$yymain .= qq~
</textarea>
    </td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="left">
    <table border="0" cellspacing="1" cellpadding="2">
    <tr>
    <td align="left" valign="top">
      <font size="2">$htltxt{'04'}:</font>
    </td>
    <td align="left" valign="top">
	<select name="hotlinkcolor" style="font-size: 10px; width: 130px">
		<option value="" $check0>$htltxt{'05'}</option>
		<option value="Black" style="color:Black" $check1>$txt{'262'}</option>
		<option value="White" style="color:White" $check2>$htltxt{'10'}</option>
		<option value="Gray" style="color:Gray" $check3>$htltxt{'11'}</option>
		<option value="Red" style="color:Red" $check4>$txt{'263'}</option>
		<option value="Yellow" style="color:Yellow" $check5>$txt{'264'}</option>
		<option value="Pink" style="color:Pink" $check6>$txt{'265'}</option>
		<option value="Green" style="color:Green" $check7>$txt{'266'}</option>
		<option value="Orange" style="color:Orange" $check8>$txt{'267'}</option>
		<option value="Purple" style="color:Purple" $check9>$txt{'268'}</option>
		<option value="Blue" style="color:Blue" $check10>$txt{'269'}</option>
		<option value="Beige" style="color:Beige" $check11>$txt{'270'}</option>
		<option value="Brown" style="color:Brown" $check12>$txt{'271'}</option>
		<option value="Teal" style="color:Teal" $check13>$txt{'272'}</option>
		<option value="Navy" style="color:Navy" $check14>$txt{'273'}</option>
		<option value="Maroon" style="color:Maroon" $check15>$txt{'274'}</option>
		<option value="LimeGreen" style="color:LimeGreen" $check16>$txt{'275'}</option>
	</select>
    </td>
    </tr>
    <tr>
    <td align="left" valign="top">
      <font size="2">$htltxt{'06'}:</font>
    </td>
    <td align="left" valign="top">
	<select name="hotlinkfont" style="font-size: 10px; width: 130px">
		<option value="" $fcheck0>$htltxt{'05'}</option>
		<option value="Arial" $fcheck1>$htltxt{'07'}</option>
		<option value="Verdana" $fcheck2>$htltxt{'08'}</option>
		<option value="Courier" $fcheck3>$htltxt{'09'}</option>
	</select>
    </td>
    </tr>
    <tr>
    <td align="left" valign="top">
      <font size="2">$htltxt{'12'}:</font><br><font size="1">$htltxt{'16'}</font>
    </td>
    <td align="left" valign="top">
	<select name="hotlinkenabl" size="3" multiple style="font-size: 10px; width: 130px">
		<option $encheck1>$htltxt{'13'}</option>
		<option $encheck2>$htltxt{'14'}</option>
		<option $encheck3>$htltxt{'15'}</option>
	</select>
    </td>
    </tr>
    </table>
    </td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center">
      <input type="submit" value="$txt{'10'}">
    </td>
  </tr>
  </form>
</table>
~;
	$yytitle = "$htltxt{'01'}";
	&template;
	exit;
}

sub SetHotlink2 {
	&is_admin;
	$FORM{'hotlink'} =~ tr/\r//d;
	$FORM{'hotlink'} =~ s~\A[\s\n]+~~;
	$FORM{'hotlink'} =~ s~[\s\n]+\Z~~;
	$FORM{'hotlink'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'hotlink'} );
	fopen(FILE, ">$vardir/hotlink.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	$hotpost = 0; $hotim = 0; $hotsign = 0; 
	if( $FORM{'hotlinkenabl'} =~ m~$htltxt{'13'}~ ) { $hotpost = 1 }
	if( $FORM{'hotlinkenabl'} =~ m~$htltxt{'14'}~ ) { $hotim = 1 }
	if( $FORM{'hotlinkenabl'} =~ m~$htltxt{'15'}~ ) { $hotsign = 1 }
	fopen(FILE, ">$vardir/hotlink.col", 1);
		print FILE "$FORM{'hotlinkcolor'}\n";
		print FILE "$FORM{'hotlinkfont'}\n";
		print FILE "$hotpost,$hotim,$hotsign\n";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	&LoadCensorList;	# Load Censor List
</search for>

<add after>
	&LoadHotlinkList;
</add after>

<search for>
		# Run UBBC interpreter on the message.
</search for>

<add before>
		if($hot_post) {
			foreach (@hotlinks) {
				($htmpa,$htmpb) = @{$_};
				my($htmp, $htmpc, $htmpc2, $tmptarget);
				($htmp,$tmptarget) = split(/\,/,$htmpa,2);
				if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
				if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
				else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
				$postmessage =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
				$postmessage =~ s~<br>~\n~g;
				$postmessage =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
				$postmessage =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			}
		}

</add before>


<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
	&LoadCensorList;	# Load censor list.
	$sender = "im";		# Fix moderator showing in info
</search for>

<add after>
	&LoadHotlinkList;
</add after>

<search for>
		$message = $immessage; # put the message back in the proper variable for doing ubbc
		&wrap;
</search for>

<add before>

		if($hot_im) {
			foreach (@hotlinks) {
				($htmpa,$htmpb) = @{$_};
				my($htmp, $htmpc, $htmpc2, $tmptarget);
				($htmp,$tmptarget) = split(/\,/,$htmpa,2);
				if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
				if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
				else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
				$immessage =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
				$immessage =~ s~<br>~\n~g;
				$immessage =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
				$immessage =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			}
		}

</add before>

<search for>
	fclose(FILE);
	&LoadCensorList;	# Load censor list.
</search for>

<add after>
	&LoadHotlinkList;
</add after>

<search for>
		$message = $immessage; # put the message back in the proper variable for doing ubbc
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
</search for>

<add after>

		if($hot_im) {
			foreach (@hotlinks) {
				($htmpa,$htmpb) = @{$_};
				my($htmp, $htmpc, $htmpc2, $tmptarget);
				($htmp,$tmptarget) = split(/\,/,$htmpa,2);
				if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
				if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
				else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
				$message =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
				$message =~ s~<br>~\n~g;
				$message =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
				$message =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			}
		}

</add after>

<search for>
		($musername, $msub, $mdate, $message, $messageid, $mips) = split( /\|/, $immessages[$INFO{'num'}]);
		# Load Censor List
		&LoadCensorList;
</search for>

<add after>
		&LoadHotlinkList;
</add after>

<search for>
		$tempdate = &timeformat($mdate);
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
		}
</search for>

<add after>

		if($hot_im) {
			foreach (@hotlinks) {
				($htmpa,$htmpb) = @{$_};
				my($htmp, $htmpc, $htmpc2, $tmptarget);
				($htmp,$tmptarget) = split(/\,/,$htmpa,2);
				if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
				if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
				else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
				$message =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
				$message =~ s~<br>~\n~g;
				$message =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
				$message =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			}
		}

</add after>


<edit file>
Sources/Load.pl
</edit file>

<search for>
sub LoadCensorList {
</search for>

<add before>

sub LoadHotlinkList {
	fopen(FILE,"$vardir/hotlink.txt") || &fatal_error("205 $txt{'106'}: $txt{'23'} hotlink.txt");
	while( chomp( $hbuffer = <FILE> ) ) {
		($htmpa,$htmpb) = split(/=/,$hbuffer,2);
		push(@hotlinks,[$htmpa,$htmpb]);
	}
	fclose(FILE);

	if(!-e ("$vardir/hotlink.col")) {
		fopen(FILE, ">$vardir/hotlink.col", 1);
		print FILE "0\n0\n1,0,0\n";
		fclose(FILE);
	}
	fopen(FILE,"$vardir/hotlink.col");
	@hotcolor = <FILE>;
	fclose(FILE);
	chomp @hotcolor;
	if($hotcolor[0]) { $hfont1 = qq~\[color=$hotcolor[0]\]~; $hfont3 = qq~\[\/color\]~; }
	else { $hfont1 = ""; $hfont3 = "" }
	if($hotcolor[1]) { $hfont2 = qq~\[font=$hotcolor[1]\]~; $hfont4 = qq~\[\/font\]~; }
	else { $hfont2 = ""; $hfont4 = "" }
	($hot_post, $hot_im, $hot_sign) = split(/\,/,$hotcolor[2]);
}

</add before>

<search for>
	&LoadCensorList;	# Load censor list
</search for>

<add after>
	&LoadHotlinkList;
</add after>

<search for>
	# do some ubbc on the signature
</search for>

<add before>

	if($hot_sign) {
		foreach (@hotlinks) {
			($htmpa,$htmpb) = @{$_};
			my($htmp, $htmpc, $htmpc2, $tmptarget);
			($htmp,$tmptarget) = split(/\,/,$htmpa,2);
			if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
			if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
			else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
			$userprofile{$user}->[5] =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
			$userprofile{$user}->[5] =~ s~<br>~\n~g;
			$userprofile{$user}->[5] =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			$userprofile{$user}->[5] =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
		}
	}

</add before>


<edit file>
Sources/Post.pl
</edit file>

<search for>
	&wrap;
	$displayname = $settings[1];
</search for>

<add before>
	&LoadHotlinkList;
	if($hot_post && $action eq "post2" || $hot_post && $action eq "modify2" || $hot_im && $action eq "imsend2") {
		foreach (@hotlinks) {
			($htmpa,$htmpb) = @{$_};
			my($htmp, $htmpc, $htmpc2, $tmptarget);
			($htmp,$tmptarget) = split(/\,/,$htmpa,2);
			if($htmpb !~ m~\Ahttp://~) { $htmpb = qq~http:\/\/$htmpb~; }
			if($tmptarget) { $htmpc = qq(\[url=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/url\]); }
			else { $htmpc = qq(\[link=$htmpb\]$hfont1$hfont2); $htmpc2 = qq($hfont4$hfont3\[\/link\]); }
			$message =~ s~ &nbsp; &nbsp; &nbsp;~\t~g;
			$message =~ s~<br>~\n~g;
			$message =~ s~(^|\s)($htmp)(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
			$message =~ s~(^|\s)(\[(?:b|i|u|s)\]$htmp\[\/(?:b|i|u|s)\])(?=$|\s|\.|\,|\;|\:|\?)~$1$htmpc$2$htmpc2~sgi;
		}
	}

</add before>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
'setcensor2',"AdminEdit.pl&SetCensor2",
</search for>

<add after>
'sethotlink',"Admin.pl&SetHotlink",
'sethotlink2',"Admin.pl&SetHotlink2",
</add after>
